
DECLARE
  v_exists INTEGER;
BEGIN
 SELECT count(*) 
    INTO v_exists 
    FROM user_tables 
    WHERE UPPER(Table_Name)='LAYERDATA_NSI';
 IF v_exists=0 THEN
  
  EXECUTE IMMEDIATE 'CREATE TABLE LayerData_NSI 
   (	
  	ID NUMBER(10,0) NOT NULL, 
	LAYERREF NUMBER(10,0) NOT NULL, 
	LAYERVERSION NUMBER(10,0), 
	FACIALACCCLS NUMBER(10,0), 
  	SENDERID NUMBER(10,0), 
	SENDERRECORDID NUMBER(10,0), 
  	SENDERID_FORCHECK NUMBER(10,0),
	RVERSION NUMBER(10,0), 
	CREATEDATE DATE NOT NULL, 
	CREATERUSER VARCHAR2(30) NOT NULL, 
	UPDATEDATE DATE NOT NULL, 
	UPDATERUSER VARCHAR2(30) NOT NULL, 
	TASKREF NUMBER(10,0), 
  "PRODUCTREF" NUMBER(10,0), 
	OWNERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	EXECUTERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	UPDATESTATUS NUMBER(10,0), 
  UPDATEDRECORDINDEX NUMBER(10,0), 
	UPDATEGROUPINDEX NUMBER(10,0), 
  ACCEPTDATE NUMBER, 
	REJECTDATE NUMBER, 
	REJECTCAUSE VARCHAR2(255), 
	NATURALKEY VARCHAR2(255), 
	DOCSTATEREF NUMBER(10,0), 
	CRYPTOSTATUS NUMBER(10,0), 
	LOCKSTATUS NUMBER(2,0), 
	LOCKINFO VARCHAR2(255), 
	DATEOPEN NUMBER, 
	DATECLOSE NUMBER, 
	BUDGETREF NUMBER(10,0), 
  
  LAYERALIAS VARCHAR2(255),
  YearReq NUMBER(10,0),
  VersionNum NUMBER(10,0),
  RequestNum NUMBER(10,0),
  Comment01 VARCHAR2(2048),
  Comment02 VARCHAR2(2048),
  CAPTIONALIAS VARCHAR2(255),
  RecordNum NUMBER(10,0),
  DetUpdCount NUMBER(10,0),
  RecordNK VARCHAR2(255),
  CaptionNK VARCHAR2(2048),
  CaptionContext VARCHAR(2048),
  STATEID NUMBER(10,0),
  STATUSID NUMBER(10,0),
  TAGVALUE  NUMBER(10,0),
  FIELDNAME VARCHAR2(255),
  RecordID NUMBER(10,0),
  CaptionID NUMBER(10,0),
  
	INTFIELD00 NUMBER(10,0), 
	INTFIELD01 NUMBER(10,0), 
	INTFIELD02 NUMBER(10,0), 
	INTFIELD03 NUMBER(10,0), 
	INTFIELD04 NUMBER(10,0), 
	DATEFIELD00 NUMBER, 
	DATEFIELD01 NUMBER, 
	STRFIELD00 VARCHAR2(1024 BYTE), 
	STRFIELD01 VARCHAR2(1024 BYTE), 
	STRFIELD02 VARCHAR2(1024 BYTE), 
	STRFIELD03 VARCHAR2(1024 BYTE), 
	STRFIELD04 VARCHAR2(1024 BYTE), 


	 CHECK ((ID<=2147483647)AND(ID>-2147483648)) ENABLE, 
	 CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)) ENABLE, 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)) ENABLE, 
	 CHECK ((FacialAccCls<=2147483647)AND(FacialAccCls>-2147483648)) ENABLE, 
	 CHECK ((IntField00<=2147483647)AND(IntField00>-2147483648)) ENABLE, 
	 CHECK ((IntField01<=2147483647)AND(IntField01>-2147483648)) ENABLE, 
	 CHECK ((IntField02<=2147483647)AND(IntField02>-2147483648)) ENABLE, 
	 CHECK ((IntField03<=2147483647)AND(IntField03>-2147483648)) ENABLE, 
	 CHECK ((IntField04<=2147483647)AND(IntField04>-2147483648)) ENABLE, 
   CHECK ((YearReq<=2147483647)AND(YearReq>-2147483648)) ENABLE,
   CHECK ((VersionNum<=2147483647)AND(VersionNum>-2147483648)) ENABLE,
   CHECK ((RequestNum<=2147483647)AND(RequestNum>-2147483648)) ENABLE,
   CHECK ((RecordNum<=2147483647)AND(RecordNum>-2147483648)) ENABLE,
   CHECK ((DetUpdCount<=2147483647)AND(DetUpdCount>-2147483648)) ENABLE,
   CHECK ((STATEID<=2147483647)AND(STATEID>-2147483648)) ENABLE,
   CHECK ((STATUSID<=2147483647)AND(STATUSID>-2147483648)) ENABLE,
   CHECK ((TAGVALUE<=2147483647)AND(TAGVALUE>-2147483648)) ENABLE,
   CHECK ((RecordID<=2147483647)AND(RecordID>-2147483648)) ENABLE,
   CHECK ((CaptionID<=2147483647)AND(CaptionID>-2147483648)) ENABLE,
  
	 CHECK ((SenderID<=2147483647)AND(SenderID>-2147483648)) ENABLE, 
	 CHECK ((SenderRecordID<=2147483647)AND(SenderRecordID>-2147483648)) ENABLE, 
	 CHECK ((Rversion<=2147483647)AND(Rversion>-2147483648)) ENABLE, 
	 CONSTRAINT "PK_LD_NSI" PRIMARY KEY ("ID"), 
	 CHECK ((TASKREF<=2147483647)AND(TASKREF>-2147483648)) ENABLE, 
   CHECK ((ProductRef<=2147483647) and (ProductRef>=-2147483648)) ENABLE,
	 CHECK ((OwnerUser<=2147483647)AND(OwnerUser>-2147483648)) ENABLE, 
	 CHECK ((ExecuterUser<=2147483647)AND(ExecuterUser>-2147483648)) ENABLE, 
	 CHECK ((UpdateStatus<=2147483647) and (UpdateStatus>=-2147483648)) ENABLE, 
	 CHECK ((UpdatedRecordIndex<=2147483647) and (UpdatedRecordIndex>=-2147483648)) ENABLE, 
	 CHECK ((UpdateGroupIndex<=2147483647) and (UpdateGroupIndex>=-2147483648)) ENABLE, 
	 CHECK ((SENDERID_FORCHECK<=2147483647) and (SENDERID_FORCHECK>=-2147483648)) ENABLE, 
	 CHECK ((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)) ENABLE, 
	 CONSTRAINT "FK_LD_NSI_LAYERREF" FOREIGN KEY ("LAYERREF")
	  REFERENCES "LAYERS" ("ID") ENABLE, 
	 CONSTRAINT "FK_LD_NSI_TASKREF" FOREIGN KEY ("TASKREF")
	  REFERENCES "LAYERTASKS" ("ID") ENABLE, 
	 CONSTRAINT "FK_LD_NSI_OWNER" FOREIGN KEY ("OWNERUSER")
	  REFERENCES "TB_DBUSERS" ("ID") ENABLE, 
	 CONSTRAINT "FK_LD_NSI_EXECUTER" FOREIGN KEY ("EXECUTERUSER")
	  REFERENCES "TB_DBUSERS" ("ID") ENABLE, 
	 CONSTRAINT "FK_LD_NSI_FACIALACCCLS" FOREIGN KEY ("FACIALACCCLS")
	  REFERENCES "TB_FACIALACC_CLS" ("ID") ENABLE
  )';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_NSI_EXECUTER ON LayerData_NSI (EXECUTERUSER)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_NSI_FACIALACCCLS ON LayerData_NSI (FACIALACCCLS)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_NSI_LAYERREF ON LayerData_NSI (LAYERREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_NSI_OWNER ON LayerData_NSI (OWNERUSER)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_NSI_TASKREF ON LayerData_NSI (TASKREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_ADATE ON LayerData_NSI (ACCEPTDATE)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_BUDGETREF ON LayerData_NSI (BUDGETREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_DATECLOSE ON LayerData_NSI (DATECLOSE)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_DATEOPEN ON LayerData_NSI (DATEOPEN)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_LAYER ON LayerData_NSI (LAYERVERSION, LAYERREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_RDATE ON LayerData_NSI (REJECTDATE)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_STATE ON LayerData_NSI (DOCSTATEREF)';


  /*   */
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_REQ ON LayerData_NSI (FACIALACCCLS,RequestNum)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_REC ON LayerData_NSI (RecordID)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_NSI_CAP ON LayerData_NSI (CaptionID)';
  
  
  EXECUTE IMMEDIATE 'COMMIT WORK';
  
 END IF;
END;
/
  

CREATE OR REPLACE TRIGGER "TR_LD_NSI_AD" after delete ON LayerData_NSI FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    
end;

/
ALTER TRIGGER "TR_LD_NSI_AD" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_NSI_AI" after insert ON LayerData_NSI FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 174) and (RecordID = :new.ID);
  
end;

/
ALTER TRIGGER "TR_LD_NSI_AI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_NSI_AU" after update ON LayerData_NSI FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=174) and (RecordId=:new.ID);
  end if;
  
end;

/
ALTER TRIGGER "TR_LD_NSI_AU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_NSI_BI" 
 BEFORE
  INSERT
 ON LayerData_NSI
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
declare
  fac NUMBER(10);
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 05.09.2005
-- Last Update 22.05.2009
-- - - - - - - - - - - - -

    if (:new.id is null) then select g_Shared.nextval into :new.Id from DUAL; end if;
    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    if ((:new.FacialAccCls is null) and (:new.TaskRef is not null)) then
      BEGIN
        select FacialAccCls into fac from LayerTasks where ID = :new.TaskRef;
        :new.FacialAccCls := fac;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    end if;
    if (:new.TaskRef is not null) then
      BEGIN
        select LayerVersion, DocStateRef, AcceptDate, RejectDate, OwnerUser, ExecuterUser
          into :new.LayerVersion, :new.DocStateRef, :new.AcceptDate, :new.RejectDate,
          :new.OwnerUser, :new.ExecuterUser
        from LayerTasks where ID = :new.TaskRef;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          :new.LayerVersion := NULL;
          :new.DocStateRef := NULL;
          :new.AcceptDate := NULL;
          :new.RejectDate := NULL;
          :new.OwnerUser := NULL;
          :new.ExecuterUser := NULL;
      END;  
    end if;
    
-- - - - - - - - - - - - -
-- BI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;

/
ALTER TRIGGER "TR_LD_NSI_BI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_NSI_BU" 
 BEFORE
  UPDATE
 ON LayerData_NSI
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 05.09.2005
-- - - - - - - - - - - - -

    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BU_700
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion+1;
  end if;

end;

/
ALTER TRIGGER "TR_LD_NSI_BU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_NSI_BU_500" before update on LayerData_NSI for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;

/
ALTER TRIGGER "TR_LD_NSI_BU_500" ENABLE;
/

GRANT SELECT, INSERT, UPDATE, DELETE ON LAYERDATA_NSI TO PUBLIC;
/




  

